﻿using Microsoft.AspNetCore.Mvc;
using ReportingServices.HelperClasses;
using ReportingServices.Models.PlanningReport;

namespace ReportingServices.Controllers
{
    public class PlanningReportController : Controller
    {
        public IActionResult Index()
        {
            return View();
        }

        public IActionResult WeeklyPartChangesReport(DateTime StartDate, DateTime EndDate)
        {
            DBCaller caller = new();

            List<WeeklyPartChanges> weeklyPartChanges = caller.GetWeeklyPartChanges(StartDate.ToString(), EndDate.ToString());
            ViewBag.NumberOfPartChanges = caller.GetNumberOfPartChanges(StartDate.ToString(), EndDate.ToString());
            ViewBag.StartDate = StartDate.ToShortDateString();
            ViewBag.EndDate = EndDate.ToShortDateString();

            return View(weeklyPartChanges);
        }
    }
}
